<?php
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //Разработчик: Федорченко А.А.
  //Версия 1.2
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //возвращает массив arr
  //$arr[0] содержит предупреждения
  //$arr[1] содержит оттипографленный текст
  //$arr[2] содержит оттипографленный текст с подсветкой и тегами (php, html, js)
  //$arr[3] содержит оттипографленный текст с подсветкой и без тегов (php, html, js)
  function typograph_process($str, $conf_file = '')
  {

    $str = trim($str);
    //цвет подсветки
    $hl_color = '#24EF8F';
    $hl_color1 = 'yellow';

    //заменить на теги подсветки
    $hl_b = "%hlb%";
    $hl_e = "%hle%";
    $hl_b1 = "%hlb1%";
    $hl_e1 = "%hle1%";

    //заменяем &nbsp; на пробелы, символы кавычек на английские
    $str = str_replace("&nbsp;", " ", $str);
    $str = str_replace("&laquo;", "\"", $str);
    $str = str_replace("&raquo;", "\"", $str);
    $str = str_replace("&quot;", "\"", $str);

    //трансформируем nbsp -> nbps
    $str = preg_replace("/&nbsp;/iu", " nbps ", $str);
    // $str = preg_replace("/&nbsp;/", " nbps ", $str);

    //выбираем из cookie массив replace, содержащий настройки
    $replace = $_COOKIE['typograph_replace'];
    $replace = unserialize(stripslashes($replace));
    if(is_array($replace))
    {
      foreach($replace as $key => $value)
      {
        if($value != 'yes')
          $value = 'yes';
      }
    }
    
    //заменяем используемые спец символы на подстановки
    $spec_chars = array('¦' => '+sym1+', '^' => '+sym2+', '¬' => '+sym3+', '±' => '+sym4+', '‰' => '+sym5+', '™' => '+sym6+', 'µ' => '+sym7+');
    foreach($spec_chars as $sym => $sym_code)
      $str = str_replace($sym, $sym_code, $str);

    //заменяем подстановки из конф. файла
    if($replace[8] != 'yes')
    {
    	 if(!empty($conf_file))
	     {
	       if(file_exists($conf_file))
	       {
	         $cfg = file_get_contents($conf_file);

	         $cfg = str_replace("\r", '', $cfg);
	         $cfg_arr = explode("\n", $cfg);

          $cnt = count($cfg_arr);
	         for($i = 0; $i < $cnt; $i++)
	         {
	           $setting = explode("\t", $cfg_arr[$i]);

            $str = str_replace($setting[0], "{$hl_b}$setting[1]{$hl_e}", $str);
	         }
	       }
	     }
    }

  //замена тегов и адресов на спецсимволы.
    //удаляем и сохраняем php-теги
    $reg = "/<\?[[a-zA-Zа-яА-Я0-9][a-zA-Zа-яА-Я0-9]]*?\?>/ui";
   	preg_match_all($reg, $str, $matches);
	   $phpcode_arr = $matches[0];
	   $str = preg_replace($reg, '^', $str);

    //удаляем и сохраняем js-теги
	   $reg = "/<script[^>]+>.*?<\/script>/ui";
	   preg_match_all($reg, $str, $matches);
	   $jscode_arr = $matches[0];
	   $str = preg_replace($reg, '¬', $str);

  /* обработка гиперссылок */
    //удаляем и сохраняем гиперссылки
    $reg = "/<a href=.+?<\/a>/ui";
    preg_match_all($reg, $str, $matches);
    $href_arr = $matches[0];
    $str = preg_replace($reg, 'µ', $str);

    //удаляем и сохраняем html-теги
	   $reg = "/<[^>]+>/ui";
	   preg_match_all($reg, $str, $matches);
	   $htmcode_arr = $matches[0];
	   $str = preg_replace($reg, '±', $str);

    if($replace[7] != 'yes')
    {
      $str = preg_replace("/[-0-9a-z_]+@[-0-9a-z_^\.]+\.[a-z]{2,3}/ui", "<a href='mailto:$0'>$0</a>", $str);
      $str = preg_replace("#(http://|www)([0-9a-z-/\.\=_\?\#&]+)#ui", "<a href='$1$2'>$1$2</a>", $str);
      $str = preg_replace("#\s+([0-9a-z-/\.\=_\?\#&]+\.(ru|com|net|info|org))#ui", " <a href='http://$1'>$1</a>", $str);
    }

    //ставим гиперссылки обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == 'µ')
      { 
        $tmp .= $href_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';

    //ставим html-код обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '±')
      { 
        $tmp .= $htmlcode_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';

  /* конец обработкиы гиперссылок */

    $reg = "/<[^>]+>/ui";
	   preg_match_all($reg, $str, $matches);
	   $htmcode_arr = $matches[0];
	   $str = preg_replace($reg, '±', $str);

    //выбираем все url адреса, заменяем их на ¦  и на ™
    $reg = "#(http://|www)[0-9a-z-/\.\=_\?\#&]+#ui";
    preg_match_all($reg, $str, $matches);
    $url_arr = $matches[0];
    $str = preg_replace($reg, '¦', $str);

    //url - адреса без http и www
    $reg = "#([0-9a-z-/\.\=_\?\#&]+\.(ru|com|net|info|org))#ui";
    preg_match_all($reg, $str, $matches);
    $url_arr2 = $matches[0];
    $str = preg_replace($reg, '™', $str);

    //удаляем и сохраняем e-mail
    $reg = "/[-0-9a-z_]+@[-0-9a-z_^\.]+\.[a-z]{2,4}/ui";
	   preg_match_all($reg, $str, $matches);
	   $email_arr = $matches[0];
	   $str = preg_replace($reg, '‰', $str);

    //три точки на троеточие
    $str = str_replace("...", "{$hl_b}&hellip;{$hl_e}", $str);

    //правильная расстановка запятых, точек, двоеточий, точек с запятой
    if($replace[3] != 'yes')
    {
	     //производим расстановку знаков
	     //$reg = '/([a-zA-Zа-яА-Я0-9]+)\s*([,:;\.])\s*([a-zA-Zа-яА-Я0-9]+)/';
	     $reg = '/([a-zA-Zа-яА-Я0-9]+)([,:;\.])([a-zA-Zа-яА-Я\.]+)/ui';
	     $replace2 = "$1{$hl_b}$2 {$hl_e}$3";
	     $str = preg_replace($reg, $replace2, $str);

	     $reg = '/([a-zA-Zа-яА-Я0-9]+)\s+([,:;\.])/ui';
	     $replace2 = "$1{$hl_b}$2 {$hl_e}$3";
	     $str = preg_replace($reg, $replace2, $str);

	     $str = preg_replace("/{$hl_b}([,:;\.]) {$hl_e}/ui", "{$hl_b}$1{$hl_e} ", $str);
      
    }

  //парные кавычки на елочки
    if($replace[0] != 'yes')
    {
      //расставляем правильно кавычки
      $str = str_replace('«', "\"", $str);
      $str = str_replace('»', "\"", $str);
      $str = str_replace('“', "\"", $str);
      $str = str_replace('”', "\"", $str);
      $str = preg_replace('/(")(±+)([a-zа-я0-9]+)/ui', "$2$1$3", $str);
      $str = preg_replace('/([a-zа-я0-9]+)(±+)(")/ui', "$1$3$2", $str);

      //print $str;     return;
      //фрагмент найден здесь http://david-m.livejournal.com/25333.html
      define("LAQUO","«");
	     define("RAQUO","»");
	     define("LDQUO","“");
	     define("RDQUO","„");


      //удаляем пробел перед закрывающей кавычкой
      $reg1 = '(\s|^|\(|\{|±|^|¬|\[|")"';
      $reg2 = '(\S)"';

        /*
	         ВЕЛИКОЕ ПРАВИЛО: Кавычки всегда прилегают к словам!

	         Открывающиеся кавычки
	         могут встречаться:
	             в начале строки,
	             после скобок "([{",
	             пробелов,
	             ещё одной кавычки
	     */ 
    	 //$str = preg_replace('{(\s|^|\(|\{|±|^|¬|µ|\[|")"}s', "\\1".LAQUO, $str);
      //$str = preg_replace('{(\s|^|\(|\{|±|^|¬|\[|")"}s', "\\1".LAQUO, $str);
      $str = preg_replace('{(\s|^|\(|\{|±|^|¬|\[|")"}us', "\\1".LAQUO, $str);
      
      // а это для тех, кто нарушает ВЕЛИКОЕ ПРАВИЛО
	     $str = preg_replace('{(\s|^|\(|\{|\[|")((?:'.TAG.'\d+'.TAG.')+)?"}us', "\\1\\2".LAQUO, $str);


       /*
	         Закрывающиеся кавычки
	         могут встречаться после
	             непробельного символа
	     */


      $str = preg_replace('{(\S)"}us', "\\1".RAQUO, $str);

      $str = preg_replace('|\s+('.LAQUO.')([^a-zа-яА-Я0-9]+)|uis', RAQUO."$2", $str);

	     // исправляем ошибки в расстановке кавычек типа ""... и ...""
	     // (предполагаем, что не более двух-трёх кавык подряд)
	     $str = preg_replace(
	             '{(^|[^'.RAQUO.'])'.LAQUO.RAQUO.'}su',
	             "\\1".LAQUO.LAQUO, $str);
	     $str = preg_replace(
	             '{(^|[^'.LAQUO.'])'.RAQUO.LAQUO.'}su',
	             "\\1".RAQUO.RAQUO, $str);
	     //    вложенные кавыки
	     $i=0; // - это защита от зацикливания (оно возможно в случае неправильно расставленных кавычек)
	     while (($i++<10) && preg_match("{".LAQUO."([^".RAQUO."]*?)".LAQUO."}us", $str))
	         $str = preg_replace(
	             "{".LAQUO."([^".RAQUO."]*?)".LAQUO."(.*?)".RAQUO."}us",
	             LAQUO."\\1".LDQUO."\\2".RDQUO, $str);

	     $i=0;
	     while (($i++<10) && preg_match("{".RAQUO."([^".LAQUO."]*?)".RAQUO."}us", $str))
	         $str = preg_replace(
	             "{".RAQUO."([^".LAQUO."]*?)".RAQUO."}us",
	             RDQUO."\\1".RAQUO, $str);
      $str = str_replace(LAQUO, "{$hl_b}&laquo;{$hl_e}", $str);
      $str = str_replace(RAQUO, "{$hl_b}&raquo;{$hl_e}", $str);
      $str = str_replace(RDQUO, "{$hl_b}&rdquo;{$hl_e}", $str);
      $str = str_replace(LDQUO, "{$hl_b}&ldquo;{$hl_e}", $str);
    }

  //двойной пробел
    if($replace[6] != 'yes')
    {
      $reg = "/[ ]{2,}/u";
      $str = preg_replace($reg, "{$hl_b} {$hl_e}", $str);
    }
    $arr[3] = $str;

  //Слепляем скобки со словами
    if($replace[1] != 'yes')
    {
    	 //$str = preg_replace('/\(\s+/', "{$hl_b}({$hl_e}", $str);
	     //$str = preg_replace('/\s+\)/', "{$hl_b}){$hl_e}", $str);
      $str = preg_replace('/([({\[])\s+/u', "{$hl_b}$1{$hl_e}", $str);
	     $str = preg_replace('/\s+([)}\]])/u', "{$hl_b}$1{$hl_e}", $str);
    }

    //дефис на тире
    if($replace[2] != 'yes')
    {
      //дефис в начале абзаца считаем за начало реплики диалога, заменяем на тире
      $str = preg_replace("/(^|\n)-/u", "{$hl_b}&#151;{$hl_e}", $str);

      //длинное тире между римскими цифрами
      $str = preg_replace("/([VIXLM]+)-([VIXLM]+)/u", "$1{$hl_b}&#151;{$hl_e}$2", $str);

      //расцепить тире от слов
      $str = preg_replace("/ +(&#151;|-)\s*([a-zа-я]+)/iu", "$1 $2 $3", $str);
      $str = preg_replace("/([a-zа-я]+)\s*(&#151;|-) +/iu", "$1 $2 $3", $str);

      //тире на длинное тире между двумя пробелами
      $str = preg_replace("/ (&#150;|-) /u", " {$hl_b}&#151;{$hl_e} ", $str);

      //дефис между годами 2004-2005, месяцами 20-21, минутами 21:20-23:40 заменяем на длинное тире
      $str = preg_replace("/([0-9]+)-([0-9]+)/u", "$1{$hl_b}&#151;{$hl_e}$2", $str);
   }


  // Размеры 10x10, правильный знак
     if($replace[4] != 'yes')
      $str = preg_replace('/(\d+)[x|X|х|Х|*](\d+)/u', "$1{$hl_b}&times;{$hl_e}$2", $str);

  //слепляем предлоги и короткие слова с предшествующим словом
    if($replace[5] != 'yes')
    {
      //короткие слова слова 1-3 символа
      $str = preg_replace("/(&nbsp;|\s)([а-я]{1,3})\s/imu", " $2&nbsp;", $str);
      $str = preg_replace("/(&nbsp;|\s)([а-я]{1,3})\s/imu", " $2&nbsp;", $str);
      $str = preg_replace("/(&nbsp;|\s)([а-я]{1,3})\s/imu", " $2&nbsp;", $str);
      $str = preg_replace("/(&nbsp;|\s)([а-я]{1,3})\s/imu", " $2&nbsp;", $str);
      $str = preg_replace("/(&nbsp;|\s)([а-я]{1,3})\s/imu", " $2&nbsp;", $str);


      $str = preg_replace("/^([а-яa-z]{1,3})\s/iu", " $1&nbsp;", $str);
      //$str = preg_replace("/(\s)([а-яА-Я]{1,3})([,]?)\s/", "$1$2$3&nbsp;", $str);
      //$str = preg_replace("/\A([а-яА-Я]{1,3})([,]?)\s/", "$1$2$3&nbsp;", $str);

      //служебные слова, больше 4-х символов
      $reg_part = "(пред|предо|между|перед|передо|либо|даже)";
      $str = preg_replace("/[^a-zа-я]{$reg_part}\s/iu", " $1&nbsp;", $str);
      $str = preg_replace("/^{$reg_part}\s/iu", " $1&nbsp;", $str);

      //цифры
      $str = preg_replace("/([0-9]+)( *)([a-zа-я]+)/iu", "$1&nbsp;$3", $str);

      //подсветка
      $str = str_replace("&nbsp;", "{$hl_b}&nbsp;{$hl_e}", $str);
    }

    //нельзя отрывать имя собственное от относящегося к нему сокражения
    $str = preg_replace('~([гГ]|гр|тов|пос|ул)\.\s*([А-Я]+)~su', "$1.{$hl_b}&nbsp;{$hl_e}$2", $str);

    // Неразрывный пробел после инициалов.
    if($replace[9] != 'yes')
    {
      $str = preg_replace('~([А-ЯA-Z]\.)\s?([А-ЯA-Z]\.)\s?([А-Яа-яA-Za-z]+)~us', "$1$2{$hl_b}&nbsp;{$hl_e}$3", $str);
    }

    //русские денежные суммы, пробелы в нужных местах
    if($replace[10] != 'yes')
    {
    	 $str = preg_replace('~(\d+)\s?(руб.)~su', "$1{$hl_b}&nbsp;{$hl_e}$2", $str);
	     $str = preg_replace('~(\d+)\s?(млн.|тыс.)?\s?(руб.)~su',	"$1{$hl_b}&nbsp;{$hl_e}$2{$hl_b}&nbsp;{$hl_e}$3", $str);
    }


    //пробел после нумерации в списке.
    $str = preg_replace("/([0-9]+\.)\s([a-zа-я]+)/iu", "$1{$hl_b} {$hl_e}$2", $str);

  //возвращаем теги и адреса на место
    //ставим php-код обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '^')
      { 
        $tmp .= $phpcode_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';

    //ставим js-код обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '¬')
      { 
        $tmp .= $jscode_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';
    
    
    //ставим url обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '¦')
      { 
        $tmp .= $url_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';

    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '™')
      { 
        $tmp .= $url_arr2[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';  
    //ставим гиперссылки обратно
    /*$cnt = mb_strlen($str);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    {
      if($str[$i] == 'µ')
      {
        $tmp .= $href_arr[$num];
        $num++;
      }
      else
        $tmp .= $str[$i];
    }
    $str = $tmp; $tmp = '';*/

    //ставим html-код обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '±')
      { 
        $tmp .= $htmcode_arr[$num];
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';  

    //ставим email-адреса обратно
    $chars = preg_split('//u', $str, -1, PREG_SPLIT_NO_EMPTY);
    $cnt = count($chars);
    $num = 0;
    for($i = 0; $i < $cnt; $i++)
    { 
      if($chars[$i] == '‰')
      { 
        $tmp .= "<a href='mailto:{$email_arr[$num]}'>{$email_arr[$num]}</a>";
        $num++;
      }
      else
        $tmp .= $chars[$i];
    }
    $str = $tmp; $tmp = '';  

    //
    $str = str_replace(" nbps ", "&nbsp;", $str);

    //ставим использованные спецсимволы обратно
    foreach($spec_chars as $sym => $sym_code)
      $str = str_replace($sym_code, $sym, $str);
    //$str = str_replace("nbsp;", "&nbsp;", $str);

    $arr[1] = str_replace($hl_b, '', $str);
    $arr[1] = str_replace($hl_e, '', $arr[1]);
    $arr[1] = str_replace($hl_b1, '', $arr[1]);
    $arr[1] = str_replace($hl_e1, '', $arr[1]);

    $arr[2] = str_replace($hl_b, "<span style='background-color:{$hl_color}'>", $str);
    $arr[2] = str_replace($hl_e, '</span>', $arr[2]);
    $arr[2] = str_replace($hl_b1, "<span style='background-color:{$hl_color1}'>", $arr[2]);
    $arr[2] = str_replace($hl_e1, '</span>', $arr[2]);


    //удаляем теги
    $arr[3] = preg_replace("/<[^>]+>/u", '', $arr[3]);
    $arr[3] = preg_replace("/^|¬|±/u", '', $arr[3]);
    $arr[3] = preg_replace("/[ ]{2,}/u", " ", $arr[3]);

    $arr[4] =  $arr[3];

    $arr[3] = str_replace($hl_b, "<span style='background-color:{$hl_color}'>", $str);
    $arr[3] = str_replace($hl_e, '</span>', $arr[3]);
    $arr[3] = str_replace($hl_b1, "<span style='background-color:{$hl_color1}'>", $arr[3]);
    $arr[3] = str_replace($hl_e1, '</span>', $arr[3]);

    //удаляем теги и подсветку
    $arr[4] = str_replace($hl_b, '', $str);
    $arr[4] = str_replace($hl_e, '', $arr[1]);
    $arr[4] = str_replace($hl_b1, '', $arr[1]);
    $arr[4] = str_replace($hl_e1, '', $arr[1]);

    return $arr;


  }
?>